package main

import (
	"fmt"
	"regexp"
)

func main() {
	expr := "135[0-9]{8}"
	reg, err := regexp.Compile(expr)
	if err != nil {
		fmt.Println(err.Error())
	}

	fmt.Println(reg.FindString("sdfsd13523591100sfdsdf"))
	flag := reg.MatchString("13523591100")
	fmt.Println(flag)
	fmt.Println(reg.FindAllString("sdfsd13523591100sfdsdfsdfsd13523591100sfdsdf", -1)) // [13523591100 13523591100]

	// 替换字符串
	fmt.Println(reg.ReplaceAllString("sdfsd13523591100sfdsdf", "135xxxx")) // sdfsd135xxxxsfdsdf

	// 分隔
	reg, err = regexp.Compile("[:;\t,]")
	fmt.Println(reg.Split("sdfsd:13523591100;sfdsdfsdfsd\t13523591100,sfdsdf", -1)) // [sdfsd 13523591100 sfdsdfsdfsd 13523591100 sfdsdf]

	// 加号表示一个
	//reg, err = regexp.Compile("[a-z]+") // [a b c d e]
	reg, err = regexp.Compile("[ab0-9]+") // [a1b2 3 4 5]
	//reg, err = regexp.Compile("(?U)[ab0-9]+") // 贪婪模式 [a 1 b 2 3 4 5]
	fmt.Println(reg.FindAllString("a1b2c3d4e5", -1))

	// 将非贪婪模式转化为贪婪模式
	reg.Longest()
	fmt.Println(reg.FindAllString("a1b2c3d4e5", -1))
}
